#include "basics.hxx"

#include "in/input_file_types.hxx"
#include "tstring.hxx"

#include <string>

#include "debug.hxx"

using std::string;


// Creators for input files.
#include "blocks/input_factory.hxx"

// The actual code, in with hidden redundancy.

namespace input
{
	const char* names[count] =
	{
		#define X(a,b,c) b
		#include "blocks/input_types.hxx"
		#undef X
	};
	const char* invalid_name = "invalid";

	#include "blocks/enummap.hxx"

	// In the future, the type will be part of the namespace
	#define FILE_TYPE input_file

	typedef FILE_TYPE* (*new_file_func)();
	static new_file_func creator[count] =
	{
		#define X(a,b,c) c
		#include "blocks/input_types.hxx"
		#undef X
	};
	#include "blocks/file_switch.hxx"

	#undef FILE_TYPE
}
